{
        ***************************************************
        *            :           *
        *                GruCredits v1.0                  *
        ***************************************************
        *   Delphi 5.                            *
        *         *
        *       -Memo                                     *
        *       -Timer                                    *
        ***************************************************
        *    ,   Winampe       *
        ***************************************************
        * :                                       *
        *     SpeedRun: integer; -       *
        *     Move: (mUp, mDown); -   *
        *     RunCredits: Boolean; - true    *
        *                                        *
        ***************************************************
        *                 11.11.01 .               *
        ***************************************************
        *      tarasui@aport.ru *
        *            (׸   )           *
        ***************************************************
}
unit GruCredits;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

var Timer: TTimer;

type
  TMove = (mUp, mDown);
  TGruCredits = class(TMemo)
  private
    { Private declarations }
    FSpeedRun: integer;
    FRunCredits: Boolean;
    FMove: TMove;
    //FTimer: TTimer;
    procedure SetSpeedRun(Value: integer);
    procedure SetRunCredits(Value: Boolean);
    procedure SetMove(Value: TMove);
  protected
    { Protected declarations }
    procedure OnTimer(Sender: TObject);
  public
    { Public declarations }
    CONSTRUCTOR Create(AOwner : TComponent); override;
    destructor  Destroy; override;
  published
    { Published declarations }
    property SpeedRun: integer read FSpeedRun write SetSpeedRun;
    property Move: TMove read FMove write SetMove;
    property RunCredits: Boolean read FRunCredits write SetRunCredits default False;
  end;

procedure Register;

implementation

CONSTRUCTOR TGruCredits.Create(AOwner : TComponent);
begin
 INHERITED Create(AOwner);
 Timer:=TTimer.Create(self);
 Timer.Enabled:=false;
 Timer.OnTimer:=OnTimer;
 Timer.Interval:=200;

 FMove:=mUp;
 Alignment:=taCenter;
 Color:=clBlack;
 Font.Color:=clYellow;
 FSpeedRun:=20;
end;

procedure TGruCredits.SetMove(Value: TMove);
begin
 if Value <> Move then
 FMove:=Value;
end;

procedure TGruCredits.OnTimer(Sender: TObject);
begin
 if Move = mDown then
 begin
 Lines.Insert(0,Lines.Strings[Lines.Count-1]);
 Lines.Delete(Lines.Count-1);
 end;
 if Move = mUp then
 begin
 Lines.Append(Lines.Strings[0]);
 Lines.Delete(0);
 end;
end;

procedure TGruCredits.SetSpeedRun(Value: integer);
begin
 if Value <> SpeedRun then
 begin
 FSpeedRun:=Value;
 Timer.Interval:=FSpeedRun * 10;
 end;
end;

procedure TGruCredits.SetRunCredits(Value: Boolean);
begin
 if Value then Timer.Enabled:=true;
 FRunCredits:=Value;
 Timer.Enabled:= Value;
end;

destructor TGruCredits.Destroy;
begin
  //Timer.Free;
  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('Grundic', [TGruCredits]);
end;

end.
